#!/bin/bash

if [ "y$1" == "y" ]; then
	echo "Usage:"
	echo "$0 build                            - builds teajs"
	echo "$0 build --v8 some_v8_path/         - builds teajs assuming another v8 location"
	echo "sudo $0 install                     - installs teajs"
	echo "$0 remoteinstall 172.168.32.1       - remote installs teajs (connects root@172.168.32.1)"
	echo "$0 clean                            - cleans project"
	exit
fi
set -e

#if [ "y$1" == "y" ]; then
	CDIR=`pwd`
	export V8_BASEDIR=$CDIR/../v8_things/v8/
#else
	#export V8_BASEDIR=$1
#fi
export TEAJS_BASEDIR=`pwd`
echo V8_BASEDIR=$V8_BASEDIR
export TEAJS_LIBPATH=$TEAJS_BASEDIR/lib
export TEAJS_VERSION=`cat VERSION`

if [ "y$1" == "ybuild" ]; then
	rm -f tea tea.exe
	rm -f lib/*.so lib/*.dll lib/*.dylib
	make -j 8
elif [ "y$1" == "yinstall" ]; then
	make -j 8 install
elif [ "y$1" == "yremoteinstall" ]; then
	export REMOTE=$2
	make -j 8 remoteinstall
elif [ "y$1" == "yclean" ]; then
	make -j 8 clean
fi

